package net.t2code.t2codelib.BUNGEE.api.plugins;

import net.md_5.bungee.api.ProxyServer;
import net.md_5.bungee.api.plugin.Plugin;
import net.t2code.t2codelib.BUNGEE.system.T2CodeBMain;

import java.util.logging.Level;

public class T2CBpluginCheck {
    public static Boolean pluginCheck(String pluginName){
        return (ProxyServer.getInstance().getPluginManager().getPlugin(pluginName) != null);
    }
    public static Plugin pluginInfos(String pluginName){
        return (ProxyServer.getInstance().getPluginManager().getPlugin(pluginName));
    }
    public static Boolean papi(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("PlaceholderAPI") != null;
    }
    public static Boolean vault(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("Vault") != null;
    }
    public static Boolean plotSquared(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("PlotSquared") != null;
    }
    public static Boolean plugManGUI(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("PlugManGUI") != null;
    }
    public static Boolean cmi(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("CMI") != null;
    }


    /**
     * T2Code Plugins
     * @return
     */
    public static Boolean cgui(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("CommandGUI") != null;
    }
    public static Boolean plotSquaredGUI(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("PlotSquaredGUI") != null;
    }
    public static Boolean luckyBox(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("T2C-LuckyBox") != null;
    }
    public static Boolean opSec(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("OPSecurity") != null;
    }
    public static Boolean papiTest(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("PaPiTest") != null;
    }
    public static Boolean booster(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("Booster") != null;
    }
    public static Boolean antiMapCopy(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("AAntiMapCopy") != null;
    }
    public static Boolean loreEditor(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("LoreEditor") != null;
    }
    public static Boolean t2cAlias(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("T2C-Alias") != null;
    }
    public static Boolean t2cWarp(){
         return ProxyServer.getInstance().getPluginManager().getPlugin("T2C-Warp") != null;
    }

    public static Boolean pluginNotFound(Plugin plugin, String prefix, String pl, Integer spigotID) {
        if (ProxyServer.getInstance().getPluginManager().getPlugin(pl) == null) {
            plugin.getLogger().log(Level.SEVERE, "Plugin can not be loaded!");
            ProxyServer.getInstance().getConsole().sendMessage(prefix + " §e" + pl + " §4could not be found. Please download it here: " +
                    "§6https://spigotmc.org/resources/" + pl + "." + spigotID + " §4to be able to use this plugin.");
            T2CodeBMain.getPlugin().getProxy().getPluginManager().getPlugin(plugin.getDescription().getName()).onDisable();
            return true;
        } else return false;
    }
}
