package net.t2code.t2codelib.BUNGEE.api.yaml;

import net.md_5.bungee.config.Configuration;
import net.t2code.t2codelib.BUNGEE.api.messages.T2CBreplace;

import java.util.ArrayList;
import java.util.List;

public class T2CBconfig {
    public static void set(String path, String value, Configuration configuration) {
        if (!configuration.contains(path)) {
            configuration.set(path, value);
        }
    }

    public static void set(String path, Configuration configuration) {
        configuration.set(path, null);
    }

    public static void set(String path, Integer value, Configuration configuration) {
        if (!configuration.contains(path)) {
            configuration.set(path, value);
        }
    }

    public static void set(String path, Double value, Configuration configuration) {
        if (!configuration.contains(path)) {
            configuration.set(path, value);
        }
    }

    public static void set(String path, Boolean value, Configuration configuration) {
        if (!configuration.contains(path)) {
            configuration.set(path, value);
        }
    }

    public static void set(String path, List<String> value, Configuration configuration) {
        if (!configuration.contains(path)) {
            configuration.set(path, value);
        }
    }


    public static String select(String prefix, String path, Configuration configuration) {
        return T2CBreplace.replace(prefix, configuration.getString(path));
    }


    public static Integer selectInt(String path, Configuration configuration) {
        return (configuration.getInt(path));
    }

    public static Boolean selectBoolean(String path, Configuration configuration) {
        return (configuration.getBoolean(path));
    }

    public static Double selectDouble(String path, Configuration configuration) {
        return (configuration.getDouble(path));
    }

    public static List<String> selectList(String path, Configuration configuration) {
        return (configuration.getStringList(path));
    }



    public static List<String> selectList(String prefix, String path, Configuration configuration) {
        List<String> output = new ArrayList<>();
        List<String> input = configuration.getStringList(path);
        for (String st : input) {
            output.add(T2CBreplace.replace(prefix, st));
        }
        return output;
    }

    public static void select(String prefix, List<String> value, String path, Configuration configuration) {
        List<String> output = new ArrayList<>();
        List<String> input = configuration.getStringList(path);
        for (String st : input) {
            output.add(T2CBreplace.replace(prefix, st));
        }
        value = output;
    }
}
