package net.t2code.t2codelib.BUNGEE.system.pluginMessaging;

import net.md_5.bungee.api.ProxyServer;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import net.md_5.bungee.api.event.PluginMessageEvent;
import net.md_5.bungee.api.plugin.Listener;
import net.md_5.bungee.event.EventHandler;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;

public class T2CplmsgBcmd implements Listener {
    @EventHandler
    public void onPluginmessage(PluginMessageEvent event) {
        if (event.getTag().equalsIgnoreCase("t2c:bcmd")) {
            event.setCancelled(true);
            DataInputStream stream = new DataInputStream(new ByteArrayInputStream(event.getData()));
            try {
                String channel = stream.readUTF();
                String input = stream.readUTF();
                if (channel.equals("T2Code-Console")) {
                    ProxyServer.getInstance().getConsole().sendMessage("Command Console: "+ input);
                    ProxyServer.getInstance().getPluginManager().dispatchCommand(ProxyServer.getInstance().getConsole(), input);
                } else {
                    ProxiedPlayer player = ProxyServer.getInstance().getPlayer(channel);
                    if (player != null) {
                        ProxyServer.getInstance().getConsole().sendMessage("Command " + player +": "+ input);
                        ProxyServer.getInstance().getPluginManager().dispatchCommand(player, input);
                    }
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
