package net.t2code.t2codelib.SPIGOT.system;

import net.milkbowl.vault.economy.Economy;
import net.milkbowl.vault.permission.Permission;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.Util;
import org.bukkit.plugin.RegisteredServiceProvider;

public class Vault {

    public static Boolean vaultEnable;
    public static Boolean connected;

    public static void loadVault() throws InterruptedException {
        long long_ = System.currentTimeMillis();
        if (T2CodeLibMain.getPlugin().getServer().getPluginManager().getPlugin("Vault") != null) {
            vaultEnable = true;
            RegisteredServiceProvider<Economy> eco = T2CodeLibMain.getPlugin().getServer().getServicesManager().getRegistration(Economy.class);
            if (eco != null) {
                T2CodeLibMain.setEco(eco.getProvider());
                if (T2CodeLibMain.getEco() != null) {
                    connected = true;
                    T2Csend.console(Util.getPrefix() + " §2Vault / Economy successfully connected!" + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
                } else {
                    connected = false;
                    T2Csend.console(Util.getPrefix() + " §4Economy could not be connected / found! [1]" + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
                }
            } else {
                connected = false;
                T2Csend.console(Util.getPrefix() + " §4Economy could not be connected / found! [2]" + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
            }
            RegisteredServiceProvider<Permission> perm = T2CodeLibMain.getPlugin().getServer().getServicesManager().getRegistration(Permission.class);
            if (perm != null) {
                T2CodeLibMain.setPerm(perm.getProvider());
            }
        } else {
            vaultEnable = false;
            connected = false;
            T2Csend.console(Util.getPrefix() + " §4Vault could not be connected! [3]" + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
        }
    }

    public static void vaultDisable() {
        if (!connected) return;
        connected = false;
        T2Csend.console(Util.getPrefix() + " §4Vault / Economy successfully deactivated.");
    }
}
