package net.t2code.t2codelib.SPIGOT.system.config.config;

import lombok.Getter;
import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;

public class SelectLibConfig {

    @Getter
    private static Boolean updateCheckOnJoin;
    @Getter
    private static Boolean t2cTestDevelopment = false;
    @Getter
    private static Integer updateCheckTimeInterval;
    @Getter
    private static Boolean seePreReleaseUpdates;
    @Getter
    private static Boolean debug;
    @Getter
    private static String language;
    @Getter
    private static Boolean bungee;
    @Getter
    private static Boolean inventoriesCloseByServerStop;

    public static void onSelect() {
        File config = new File(T2CodeLibMain.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        if (yamlConfiguration.contains("t2cTestDevelopment")) {
            t2cTestDevelopment = yamlConfiguration.getBoolean("t2cTestDevelopment");
        }

        updateCheckOnJoin = yamlConfiguration.getBoolean("Plugin.UpdateCheck.OnJoin");
        updateCheckTimeInterval = yamlConfiguration.getInt("Plugin.UpdateCheck.TimeInterval");
        seePreReleaseUpdates = yamlConfiguration.getBoolean("Plugin.UpdateCheck.SeePreReleaseUpdates");
        debug = yamlConfiguration.getBoolean("Plugin.Debug");
        language = yamlConfiguration.getString("Plugin.language");
        bungee = yamlConfiguration.getBoolean("BungeeCord.Enable");
        inventoriesCloseByServerStop = yamlConfiguration.getBoolean("Player.Inventories.CloseByServerStop");
    }
}
