package net.t2code.t2codelib.SPIGOT.system;

import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class T2CbungeeCommandSenderReciver {

    public static void sendToBungee(CommandSender sender, String information, Boolean console) {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            if (console) {
                output.writeUTF("T2Code-Console");
            } else {
                if (sender instanceof Player) {
                    output.writeUTF(sender.getName());
                } else {
                    output.writeUTF("T2Code-Console");
                }
            }
            output.writeUTF(information);
        } catch (IOException e) {
            e.printStackTrace();
        }
        if (sender instanceof Player) {
            Player player = (Player) sender;
            player.sendPluginMessage(T2CodeLibMain.getPlugin(), "t2c:bcmd", stream.toByteArray());
        }else {
            for(Player player : Bukkit.getOnlinePlayers()){
                player.sendPluginMessage(T2CodeLibMain.getPlugin(), "t2c:bcmd", stream.toByteArray());
                return;
            }
        }
    }

}
