package net.t2code.t2codelib.SPIGOT.system.cmd;

import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class ReportLogStorage {
    public static List<String> list = new ArrayList<>();

    protected static File config = new File(T2CodeLibMain.getPath(), "/DebugLogs/T2CodeReportKeys.yml");
    protected static YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

    public static void add(String key) {
        list.add(key);
        save();
    }

    public static void remove(String key) {
        list.remove(key);
        save();
    }

    public static void save() {
        if (list == null) return;
        yamlConfiguration.set("Keys", list);

        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void load() {
        if (!config.exists()) return;
        list = yamlConfiguration.getStringList("Keys");
    }
}
